unit comtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, com485, ExtCtrls;

type
  TForm1 = class(TForm)
    TimerRead: TTimer;
    Panel1: TPanel;
    LabelHex: TLabel;
    Read: TLabel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    EditSend: TEdit;
    ButtonSend: TButton;
    ButtonClear: TButton;
    ButtonOptions: TButton;
    EditHex: TEdit;
    ButtonSendHex: TButton;
    procedure ButtonOptionsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonSendClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure TimerReadTimer(Sender: TObject);
    procedure ButtonSendHexClick(Sender: TObject);
  private
    { Private declarations }
    com : TCom485;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const crlf = #13#10;


procedure TForm1.ButtonOptionsClick(Sender: TObject);
begin
  com.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Com := TCom485.Create(self);
  Com.OpenPort;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Com.Destroy;
end;

procedure TForm1.ButtonSendClick(Sender: TObject);
begin
  Com.Write(EditSend.Text);
end;

procedure TForm1.ButtonClearClick(Sender: TObject);
begin
  Read.Caption := '';
  LabelHex.Caption := '';
end;

procedure TForm1.TimerReadTimer(Sender: TObject);
var n : integer; s: ShortString;
begin
  n := Com.InCount;
  if ( n <= 0 ) then exit;
  s := Com.ReadN(n);
  Read.Caption := Read.Caption + s;
  LabelHex.Caption := LabelHex.Caption + StrToHexStr(s);
end;


procedure TForm1.ButtonSendHexClick(Sender: TObject);
var s,h:string; crc,len,i:integer; r:ShortString;
begin
  s := EditHex.text;
  len := Length(EditHex.text);
  r := '';
  i := 1;
  while ( i < len ) do begin
    if ( Pos(s[i],'$ ,;/|') > 0 ) then begin i := i + 1; continue; end;
    h := '$' + s[i] + s[i+1]; i := i + 2;
    r := r + Char(StrToInt(h));
  end;
  Com.Write(r);
end;

end.
