#include <stdio.h>
#include <string.h>
#include "crc.h"

void printmsg(const unsigned char *data,int len)
{
  int i;
  unsigned short crc = CRC16(data,len);
  for (i=0; i<len; i++)
    printf("%02x ",data[i]);
  printf("%04x ",crc);
  printf("%04x \n",crc16_2(data,len));

}

#define PRINT(d) printmsg(d,sizeof(d))
#define PRINTS(s) printmsg(s,strlen((const char *)s))
int main(void)
{
  unsigned char data1[] = {0x11,0x05,0x00,0xac,0xff,0x00};
  unsigned char data2[] = {0x02,0x07};
  unsigned char data3[] = {0x0a,0x81,0x02};
  unsigned char data4[] = "Kissa";
  unsigned char data5[] = "a";
  PRINT(data1);
  PRINT(data2);
  PRINT(data3);
  PRINTS(data4);
  PRINTS(data5);
  return 0;
}

