unit YasStart;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  KYasPar,kErrors,kModbus, StdCtrls, ExtCtrls;

type
  TFormYasStart = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    params:TYasParams;
    modbus:TModbus;
    Errors : TErrors;
  public
  end;

var
  FormYasStart: TFormYasStart;

implementation

{$R *.DFM}

procedure TFormYasStart.FormCreate(Sender: TObject);
begin
  Modbus := TModbus.Create(self);
  params := TYasParams.Create(self);
  Errors := TErrors.Create(self);

//  Errors.Show;
  ModBus.Errors := Errors;
  params.Modbus := Modbus;
  params.CreateList3('Yaskawa','.\Yaskawa.ini','.\Yasmotor.ini','Params');

  if ( ParamCount > 0 ) then begin
    Modbus.Port := StrToInt(ParamStr(1));
  end;
  if ( Modbus.Port <> 0 ) then Modbus.Open;

  params.ShowControl;

end;

procedure TFormYasStart.FormDestroy(Sender: TObject);
begin
  Params.Free;
  Modbus.Free;
  Errors.Free;
end;

procedure TFormYasStart.Button1Click(Sender: TObject);
begin
  params.ShowControl;
end;

procedure TFormYasStart.Button2Click(Sender: TObject);
begin
  Close;
end;

end.
